#Lang "fblite"
#Include Once "win/winsock.bi"
#Include Once "SDL/SDL.bi"

Dim Shared updatedelay As ULong = 100
Dim Shared vidmode As Integer
Dim Shared ret As Integer
Dim Shared closeapp As Integer
Dim Shared wsad As WSAData
'Dim Shared newevent As WSAEVENT
Dim shared s as SOCKET
Dim Shared r as SOCKET
Dim Shared addr As SOCKADDR_IN
Dim Shared addr2 As SOCKADDR_IN
Dim Shared addr2size As Integer
Dim Shared ipstring As String
Dim Shared outstring As String
Dim Shared instring As String * 1406
Dim Shared char(255, 7, 15) As UByte
'Dim Shared scr(24, 159) As UByte
Dim Shared scr(65535) As UByte
Dim Shared PaletteCGA(15) As Long
Dim Shared cursx As Integer = 0
Dim shared cursy As Integer = 0
Dim Shared cursorvisible As UByte
Dim Shared cursortimer As ULong

Declare Sub drawscreen()
Declare Function TranslateScancode(ByVal keyval As UInteger) As UInteger
Dim Shared video as SDL_Surface ptr
Dim Shared event as SDL_Event

Print "Remoter v0.11.8.8 (c)2011 Mike Chambers"
Print "[Client for the DOS Remoter server]"
Print

If Command$ = "" Then
	Print "Specify server IP on command line."
	Print
	Print "Syntax: remoter.exe <server hostname/IP> [-delay #]"
	Print
	Print "  The optional -delay # parameter allows you to specify how many"
	Print "  milliseconds to wait between screen update requests are sent"
	Print "  to the Remoter server. The default value is 100 ms."
	Print
	Print "  The 50 to 100 ms range is a good setting in most situations over"
	Print "  a LAN or other low-latency connections. If the server is running"
	Print "  on a very slow computer such as one with an 8088 CPU, it is a good"
	Print "  idea to use a value like 200 ms, which can dramatically lower the"
	Print "  overhead of the system."
	End
End If

For n = 2 To 5
	curarg$ = Command(n)
	If curarg$ = "" Then Exit For
	Select Case LCase$(curarg$)
		Case "-delay"
			n = n + 1
			updatedelay = Val(Command(n))
			Print "Using refresh delay of " + Str$(updatedelay) + " ms."
	End Select
Next n
Open "asciivga.dat" For Binary As #1
For n = 0 To 255
	For y = 0 To 15
		For x = 0 To 7
			Get #1, , char(n,x,y)
		Next x
	Next y
Next n
Close #1
PaletteCGA(0) = 0
PaletteCGA(1) = RGB(0, 0, &HAA)
PaletteCGA(2) = RGB(0, &HAA, 0)
PaletteCGA(3) = RGB(0, &HAA, &HAA)
PaletteCGA(4) = RGB(&HAA, 0, 0)
PaletteCGA(5) = RGB(&HAA, 0, &HAA)
PaletteCGA(6) = RGB(&HAA, &H55, 0)
PaletteCGA(7) = RGB(&HAA, &HAA, &HAA)
PaletteCGA(8) = RGB(&H55, &H55, &H55)
PaletteCGA(9) = RGB(&H55, &H55, &HFF)
PaletteCGA(10) = RGB(&H55, &HFF, &H55)
PaletteCGA(11) = RGB(&H55, &HFF, &HFF)
PaletteCGA(12) = RGB(&HFF, &H55, &H55)
PaletteCGA(13) = RGB(&HFF, &H55, &HFF)
PaletteCGA(14) = RGB(&HFF, &HFF, &H55)
PaletteCGA(15) = RGB(&HFF, &HFF, &HFF)

ipstring = Command(1)+Chr$(0)
Print "Connecting to " + ipstring

if (WSAStartup(&h101, @wsad))=-1 then
      Print "Error initting Winsock."
      End
end If

s = opensocket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)
If s = SOCKET_ERROR Then Print "Socket creation failed!": End
addr.sin_family = AF_INET
addr.sin_port = htons(9001)
addr.sin_addr.s_addr = inet_addr(ipstring)

r = OpenSocket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)
If r = SOCKET_ERROR Then Print "Socket creation failed!": End
addr2.sin_family = AF_INET
addr2.sin_port = htons(9002)
addr2.sin_addr.s_addr = htonl(INADDR_ANY)
If bind(r, @addr2, sizeof(addr2)) = SOCKET_ERROR Then
	Print "Error binding UDP port 9002!"
	End
End If

video = SDL_SetVideoMode(640, 400, 32, 0)   'or SDL_FULLSCREEN
If video = 0 Then
	Print "FATAL: SDL unable to initialize video window!"
	SDL_Quit
	End
End If
SDL_WM_SetCaption("Remoter client", 0)

outstring = Chr$(&HE8) + Chr$(&H3)
ret = sendto(s, outstring, Len(outstring), 0, @addr, sizeof(addr))

Declare Sub recvwait() 
Dim Shared recvthread As Any Ptr
recvthread = ThreadCreate(@recvwait)
ret=0

Dim Shared updatetimer As Long
Do
	If ret > 0 Then
		startscr = CVShort(Left$(instring, 2))
		For n = 7 To 1406
			scr(startscr + n - 7) = Asc(Mid$(instring, n, 1))
		Next n
		cursx = Asc(Mid$(instring, 3, 1))
		cursy = Asc(Mid$(instring, 4, 1))
		vidmode = Asc(Mid$(instring, 5, 1))
		'Print Hex$(vidmode)
		drawscreen
		ret = 0
	End If

	SDL_PumpEvents
	If SDL_PollEvent(@event) Then
		Select Case As Const event.type
			Case SDL_KEYDOWN
				orig = event.key.keysym.sym
				tsc = TranslateScancode(orig)
				outstring = Chr$(&HEA) + Chr$(&H3) + Chr$(tsc) + Chr$(orig Shr 8)
				ret = sendto(s, outstring, Len(outstring), 0, @addr, sizeof(addr))
			Case SDL_KEYUP
				orig = event.key.keysym.sym
				tsc = TranslateScancode(orig) Or &h80
				outstring = Chr$(&HEA) + Chr$(&H3) + Chr$(tsc) + Chr$(orig Shr 8)
				ret = sendto(s, outstring, Len(outstring), 0, @addr, sizeof(addr))
			Case SDL_QUIT_
			  Exit Do
		End Select
	End If

	If (SDL_GetTicks() - cursortimer) >= 333 Then
		If cursorvisible = 1 Then cursorvisible = 0 Else cursorvisible = 1
		cursortimer = SDL_GetTicks()
		drawscreen
	End If

	If (SDL_GetTicks() - updatetimer) >= updatedelay Then
		updatetimer = SDL_GetTicks()
		outstring = Chr$(&HEB) + Chr$(&H3)
		ret = sendto(s, outstring, Len(outstring), 0, @addr, sizeof(addr))
	End If

	SDL_Delay(10)
Loop
closeapp = 1
outstring = Chr$(&HE9) + Chr$(&H3)
ret = sendto(s, outstring, Len(outstring), 0, @addr, sizeof(addr))

closesocket(s)
closesocket(r)
WSACleanup()
End

Sub recvwait()
	addr2size = SizeOf(addr2)
	Do Until closeapp = 1
	  Do: SDL_Delay(10): Loop Until ret = 0
	  If closeapp = 1 Then Exit Do
	  ret = recvfrom(r, instring, Len(instring), 0, @addr2, @addr2size)
	Loop
End Sub

Sub drawscreen()
	Dim vidptr, curpixel As UInteger
	Dim As UInteger Ptr pixel

	SDL_LockSurface (video)
	
 Select Case vidmode
 	Case 4, 5
		usepal = (Asc(Mid$(instring, 6, 1))\32) And 1
		intensity = ((Asc(Mid$(instring, 6, 1))\16) And 1) * 8
 		For y = 0 To 399
 			For x = 0 To 639
	    		charx = x\2
    			chary = y\2
  				vidptr = ((chary\2) * 80) + ((chary Mod 2) * 8192) + (charx \ 4)
    			curpixel = scr(vidptr)
    			Select Case As Const charx Mod 4
    				Case 3: curpixel = curpixel And 3
    				Case 2: curpixel = (curpixel\4) And 3
    				Case 1: curpixel = (curpixel\16) And 3
    				Case 0: curpixel = (curpixel\64) And 3
    			End Select
    			'curpixel = PaletteCGA(curpixel)
 				pixel = video->pixels + y*video->pitch + x*len( integer )
    			If vidmode = 4 Then
    				curpixel = curpixel * 2 + usepal + intensity
    				If curpixel = usepal + intensity Then curpixel = cgabg
    				*pixel = PaletteCGA(curpixel)
    			Else
    				curpixel = curpixel * 63
    				*pixel = RGB(curpixel, curpixel, curpixel)    				
    			End If 
			Next x
 		Next y
 	
 	Case 6
 	For y = 0 To 399
    	For x = 0 To 639
	    		charx = x
    			chary = y\2
  				vidptr = videobase + ((chary\2) * 80) + ((chary Mod 2) * 8192) + (charx \ 8)
    			curpixel = scr(vidptr)
    		Select Case As Const x Mod 8
    			Case 7: curpixel = curpixel And 1
    			Case 6: curpixel = (curpixel\2) And 1
    			Case 5: curpixel = (curpixel\4) And 1
    			Case 4: curpixel = (curpixel\8) And 1
    			Case 3: curpixel = (curpixel\16) And 1
    			Case 2: curpixel = (curpixel\32) And 1
    			Case 1: curpixel = (curpixel\64) And 1
    			Case 0: curpixel = (curpixel\128) And 1
    		End Select
    		pixel = video->pixels + y * video->pitch + x * len( integer )
    		*pixel = PaletteCGA(curpixel*15)
    	Next x
	Next y


 	Case &h13
 		For y = 0 To 399
 			For x = 0 To 639
 				vidptr = (y Shr 1)*320 + (x Shr 1)
 				curidx = scr(vidptr)
 				curpixel = RGB(curidx, curidx, curidx)
 				pixel = video->pixels + y*video->pitch + x*len( integer )
    			*pixel = curpixel
 			Next x
 		Next y
 		
  Case Else
	For curl = 0 To 24
	 For curc = 0 To 159 Step 2
	 	'charidx = scr(curl, curc)
	 	'fore = scr(curl, curc+1)
	 	vidptr = curl*160 + curc
	 	charidx = scr(vidptr)
	 	fore = scr(vidptr+1)
	 	back = (fore Shr 4) And 7
	 	fore = fore And 15
		For y = 0 To 15
			For x = 0 To 7
				curpixel = char(charidx, x, y)
				If curpixel = 0 Then curpixel = PaletteCGA(back) Else curpixel = PaletteCGA(fore)
				'If (cursorvisible = 0) And (scr(vidptr+1) And &h80) Then curpixel = PaletteCGA(back)
				If (cursy = curl) And (cursx = (curc Shr 1)) Then
					If (cursorvisible = 1) And (y > 10) And (y < 14) Then curpixel = PaletteCGA(fore)
				End If
				'PSet((curc Shr 1)*8+x, curl*16+y), curpixel 
    			pixel = video->pixels + ((curl*16)+y) * video->pitch + (((curc Shr 1)*8) + x) * len( integer )
    			*pixel = curpixel
			Next x
		Next y
	 Next curc
	Next curl
 End Select
	
	SDL_UnlockSurface (video)
	SDL_Flip video
End Sub

Function TranslateScancode(ByVal keyval As UInteger) As UInteger
	Dim sc As UInteger
	'Print "TRANSLATESCANODE INPUT: " + Hex$(keyval)
	Select Case As Const keyval
		Case &h1B: sc = 1 'Esc
		Case &h30: sc = &hB 'zero
		Case &h31 To &h39: sc = keyval - &h2F 'other number keys
		Case &h2D: sc = &hC '-_
		Case &h3D: sc = &hD '=+
		Case &h8: sc = &hE 'backspace
		Case &h9: sc = &hF 'tab
		Case &h71: sc = &h10 'Q
		Case &h77: sc = &h11 'W
		Case &h65: sc = &h12 'Q
		Case &h72: sc = &h13 'W
		Case &h74: sc = &h14 'Q
		Case &h79: sc = &h15 'W
		Case &h75: sc = &h16 'Q
		Case &h69: sc = &h17 'W
		Case &h6F: sc = &h18 'Q
		Case &h70: sc = &h19 'W
		Case &h5B: sc = &h1A 'Q
		Case &h5D: sc = &h1B 'W
		Case &hD, &h10F: sc = &h1C 'enter
		Case &h131, &h132: sc = &h1D 'ctrl
		Case &h61: sc = &h1E 'Q
		Case &h73: sc = &h1F 'W
		Case &h64: sc = &h20 'Q
		Case &h66: sc = &h21 'W
		Case &h67: sc = &h22 'Q
		Case &h68: sc = &h23 'W
		Case &h6A: sc = &h24 'Q
		Case &h6B: sc = &h25 'W
		Case &h6C: sc = &h26 'Q
		Case &h3B: sc = &h27 'W
		Case &h27: sc = &h28 'Q
		Case &h60: sc = &h29 'W
		Case &h130: sc = &h2A 'left shift
		Case &h5C: sc = &h2B 'W
		Case &h7A: sc = &h2C 'Q
		Case &h78: sc = &h2D 'W
		Case &h63: sc = &h2E 'Q
		Case &h76: sc = &h2F 'W
		Case &h62: sc = &h30 'Q
		Case &h6E: sc = &h31 'W
		Case &h6D: sc = &h32 'Q
		Case &h2C: sc = &h33 'W
		Case &h2E: sc = &h34 'Q
		Case &h2F: sc = &h35 'W
		Case &h12F: sc = &h36 'right shift
		Case &h13C: sc = &h37 'print screen 
		Case &h133, &h134: sc = &h38 'alt
		Case &h20: sc = &h39 'space
		Case &h12D: sc = &h3A 'caps lock
		Case &h11A To &h123: sc = keyval - &h11A + &h3B 'F1 to F10
		Case &h12C: sc = &h45 'num lock
		Case &h12E: sc = &h46 'scroll lock
		Case &h116, &h107: sc = &h47 'home
		Case &h111, &h108: sc = &h48 'up
		Case &h118, &h109: sc = &h49 'pgup
		Case &h10D: sc = &h4A 'keypad -
		Case &h114, &h104: sc = &h4B 'left
		Case &h105: sc = &h4C 'center
		Case &h113, &h106: sc = &h4D 'right
		Case &h10E: sc = &h4E 'keypad +
		Case &h117, &h101: sc = &h4F 'end
		Case &h112, &h102: sc = &h50 'down
		Case &h119, &h103: sc = &h51 'pgdn
		Case &h115, &h100: sc = &h52 'ins
		Case &h7F, &h10A: sc = &h53 'del
	End Select
	TranslateScancode = sc
End Function
