;not going to bother with doing any sort of buffering for ARP packets.
;the processing is so quick even at 4.77 MHz, it would be a waste of RAM.

recv_arp:
  pushall
  cli
  cld
  mov ax, cs
  mov ds, ax
  mov es, ax
  mov si, offset recv_data

  lodsw
  cmp ax, 100h ;should be ethernet type
  jne recv_arp_done2

  lodsw
  cmp ax, 8 ;should be IPv4 type
  jne recv_arp_done2
  lodsw ;don't need to examine this, we know address sizes for ethernet/IPv4

  lodsw ;get operation value
  cmp ax, 100h
  je recv_arp_request
  cmp ax, 200h
  jne recv_arp_done

  ;if we've made it here, it's an ARP reply. see if it's from our gateway.
  ;push si
  ;push di
  ;push cx
  mov si, offset gateway_ip
  mov di, offset recv_data+14 ;compare gateway_ip against ARP pkt sender ip
  mov cx, 4
  check_arp_reply_loop:
	cmpsb
	jne recv_arp_done ;reply_done
	loop check_arp_reply_loop
  ;if we've made it here, it's our gateway's reply!
  mov si, offset recv_data+8 ;copy our gateway's MAC
  mov di, offset gateway_mac ;into our array for it
  mov cx, 3
  rep movsw
  recv_arp_reply_done:
  ;pop cx
  ;pop di
  ;pop si
  ;jmp recv_arp_done
  recv_arp_done2: ;here for an earlier call that original is out of range for
	popall
	ret

  recv_arp_request:
  add si, 16 ;skip SI to target protocol address in ARP packet
  mov di, offset local_ip
  call does_ip_match
  jc recv_arp_done ;it's not for us

  ;it's for us, let's form the reply packet
  mov si, offset recv_data
  mov di, offset pkt_data
  mov cx, 3 ;copy first 6 bytes verbatim
  rep movsw

  mov ax, 200h
  stosw ;operation type is reply

  mov si, offset recv_data+8 ;skip SI to sender's address block
  mov di, offset pkt_data+18 ;and DI to new packet's target block
  mov cx, 5 ;copy 10 bytes
  rep movsw

  ;source ptr is now at original packet's target block, so let's
  ;just move the destination ptr to the new packet's sender block
  mov di, offset pkt_data+8
  mov cx, 5 ;copy 10 more bytes
  rep movsw
  mov di, offset pkt_data+8 ;now go back to sender's hardware address field
  mov si, offset local_mac ;and fill it in with our MAC
  mov cx, 3 ;copy those 6 bytes
  rep movsw

  ;copy original sender's MAC one more time, for the ethernet header
  mov si, offset recv_data+8
  mov di, offset pkt_dest
  mov cx, 3
  rep movsw
  mov si, offset local_mac ;and our MAC in the source field
  mov cx, 3
  rep movsw
  mov ax, 0608h ;ARP is ethertype 0x0806
  stosw

  ;at this point our packet is ready! set length in CX, and call send_pkt
  mov cx, 28
  call send_pkt
  ;mov si, offset strinarp
  ;call printmsg

recv_arp_done:
  call tcp_check_arp_reply
  popall
  ret


;enter with near pointers (in CS) to two MAC addresses, in SI and DI.
;carry flag will be cleared on return if they match, set if not.
does_mac_match:
  pushall
  cld
  mov ax, cs
  mov ds, ax
  mov cx, 6
  mac_match_loop:
	lodsb
	mov ah, [di]
	inc di
	cmp ah, al
	jne mac_no_match
	loop mac_match_loop
  popall
  clc
  ret

mac_no_match:
  popall
  stc
  ret


;enter with near pointers (in CS) to two IP addresses, in SI and DI.
;carry flag will be cleared on return if they match, set if not.
does_ip_match:
  pushall
  cld
  mov ax, cs
  mov ds, ax
  mov cx, 4
  ip_match_loop:
	lodsb
	mov ah, [di]
	inc di
	cmp ah, al
	jne ip_no_match
	loop ip_match_loop
  popall
  clc
  ret

ip_no_match:
  popall
  stc
  ret

strinarp db '[DEBUG] ARP packet processed', 13, 10, 0
