ip_recv_pkt:
ip_ver_hdr_len db 0
ip_ignore      db 0
ip_total_len   dw 0
ip_ident       dw 0
ip_flags_frag  dw 0
ip_ttl         db 0
ip_protocol    db 0
ip_hdr_chksum  dw 0
ip_src         db 4 dup (0)
ip_dest        db 4 dup (0)

ip_data dw MTU dup (0)

ip_send_pkt:
ip_send_ver_hdr_len db 01000101b ;always version 4 (top nibble), hdr size 5
ip_send_ignore      db 0
ip_send_total_len   dw 0
ip_send_ident       dw 1234h
ip_send_flags_frag  dw 01000000b
ip_send_ttl         db 128
ip_send_protocol    db 0
ip_send_hdr_chksum  dw 0
ip_send_src         db 4 dup (0)
ip_send_dest        db 4 dup (0)

ip_send_data dw MTU dup (0)

ip_ver      db 0
ip_hdr_len  dw 0
ip_tot_len  dw 0
ip_data_len dw 0
ip_frag     db 0
recv_ip:
  pushall
  cld
  mov ax, cs
  mov ds, ax
  mov es, ax
  mov si, offset recv_data
  mov di, offset ip_recv_pkt
  mov cx, 10
  rep movsw

  mov si, offset ip_dest
  ;call printip
  ;call crlf

  mov di, offset local_ip
  call does_ip_match
  jc ip_done2
  ;mov si, offset strrecvip
  ;call printmsg

  ;alright, this one's for us!
  mov al, [ip_ver_hdr_len]
  and al, 15 ;mask header length field
  xor ah, ah ;clear top half of AX
  shl ax, 1 ;IP header length field is actually div. 4
  shl ax, 1 ;so expand the value back to bytes
  mov [ip_hdr_len], ax ;and save header len value

  and [ip_flags_frag], 00111111b ;mask out reserved and don't fragment bits
  cmp [ip_flags_frag], 0
  jz ip_not_frag
  mov si, offset stripfrag
  call printmsg
  jmp ip_done

  ip_done2:
	popall
	ret

  ip_not_frag:
	mov ax, [ip_total_len]
	xchg ah, al
	mov [ip_tot_len], ax
	sub ax, [ip_hdr_len]
	mov [ip_data_len], ax
	cmp [ip_data_len], 1480
	;mov ax, [ip_data_len]
	;call print_dec
	;call crlf
	jbe ip_size_okay
	mov di, offset striphuge
	jmp ip_done

  ip_size_okay:
	;mov si, offset strpktsize
	;call printmsg
	mov ax, [ip_data_len] ;put length into AX for debug printout
	;call print_dec
	;call crlf

	mov si, offset recv_data
	add si, [ip_hdr_len]
	mov di, offset ip_data
	mov cx, ax ;put total length into CX for rep movsb
	rep movsb ;and copy it to the ip_data buffer
	xor al, al
	stosb ;and a trailing null byte to make checksums correct on odd lengths

	cmp [ip_protocol], 1
	jne ip_not_icmp
	;mov si, offset strisicmp
	;call printmsg
	call icmp_recv
	jmp ip_done

  ip_not_icmp:
	cmp [ip_protocol], 17
	jne ip_not_udp
	;mov si, offset strisudp
	;call printmsg
	call udp_recv
	jmp ip_done

  ip_not_udp:
	cmp [ip_protocol], 6
	jne ip_done
	call tcp_recv

  ip_done:
	popall
	ret

ip_send_is_tcp db 0 ;TCP layer sets before ip_send so we skip subnet_check
ip_send:
  pushall
  cld
  mov ax, cs
  mov ds, ax
  mov es, ax
  mov [ip_send_hdr_chksum], 0 ;make sure this is zero for checksum calc

  add [ip_send_total_len], 20 ;IP header is 20 bytes
  mov ax, [ip_send_total_len]
  xchg ah, al ;byteswap total length to network byte order
  mov [ip_send_total_len], ax

  mov di, offset ip_send_src
  mov si, offset local_ip
  mov cx, 2
  rep movsw

  mov ax, [ip_send_ident]
  xchg ah, al
  inc ax
  xchg ah, al
  mov [ip_send_ident], ax

  xor bx, bx ;BX will be our accumulator when calculating checksum
  mov si, offset ip_send_pkt
  mov cx, 10
  clc
  loop_calc_ip_chksum:
	lodsw
	xchg ah, al ;byteswap it
	adc bx, ax
	loop loop_calc_ip_chksum
  adc bx, 0 ;account for any left over carry bit
  not bx ;one's complement the accumulated value
  xchg bh, bl
  mov [ip_send_hdr_chksum], bx ;insert checksum into IP header

  mov di, offset pkt_dest
  ;mov ax, 0E690h ;1700h
  ;stosw
  ;mov ax, 80BAh ;3B9Ah
  ;stosw
  ;mov ax, 9EF9h ;0D739h
  ;stosw
  mov cx, 3
  mov di, offset pkt_src
  mov si, offset local_mac
  rep movsw
  mov ax, 0008h ;0x8000 in network byte order is means IP ethertype
  stosw

  cmp cs:[ip_send_is_tcp], 1
  je skip_subnet_check
  call subnet_check

  skip_subnet_check:
  mov cs:[ip_send_is_tcp], 0 ;reset the flag
  mov si, offset ip_send_pkt
  mov di, offset pkt_data
  mov cx, [ip_send_total_len]
  xchg ch, cl
  push cx
  rep movsb
  xor al, al
  stosb
  pop cx

  call send_pkt

  popall
  ret

subnet_temp  db 4 dup (0)
subnet_temp2 db 4 dup (0)
subnet_check:
  mov si, offset ip_send_dest
  mov di, offset subnet_temp
  mov cx, 4
  rep movsb
  mov si, offset local_ip
  mov di, offset subnet_temp2
  mov cx, 4
  rep movsb
  mov si, offset subnet
  mov di, offset subnet_temp
  mov cx, 4
  subnet_loop:
	lodsb
	and al, [di]
	stosb
	loop subnet_loop
  mov si, offset subnet
  mov di, offset subnet_temp2
  mov cx, 4
  subnet_loop2:
	lodsb
	and al, [di]
	stosb
	loop subnet_loop2
  mov si, offset subnet_temp
  mov di, offset subnet_temp2
  mov cx, 4
  subnet_loop3:
	cmpsb
	jne insert_gateway_mac
	loop subnet_loop3
  mov di, offset pkt_dest
  mov ax, 0FFFFh
  mov cx, 3
  rep stosw
  ret

insert_gateway_mac:
  mov si, offset gateway_mac
  mov di, offset pkt_dest
  mov cx, 3
  rep movsw
  ret

strrecvip  db '[DEBUG] IP packet for us received!', 13, 10, 0
stripfrag  db '[DEBUG] IP packet is fragmented! Dropping.', 13, 10, 0
striphuge  db '[DEBUG] IP packet is over 1500 bytes! Dropping.', 13, 10, 0
strisicmp  db '[DEBUG] Packet is ICMP protocol!', 13, 10, 0
strpktsize db '[DEBUG] IP data payload size: ', 0
strisudp   db '[DEBUG] Packet is UDP protocol!', 13, 10, 0
 