;remoter.asm (c)2011 Mike Chambers
;a VNC-like remote control application for DOS

.model tiny
.code

org 100h
entry_point:
mov ax, cs
mov ds, ax
mov es, ax

mov si, offset strwelcome
call printmsg

call hook_udp

mov ax, 3508h
int 21h
mov ax, es
mov [old_timer_ptr], bx
mov [old_timer_seg], ax

;mov ax, 2508h
;mov dx, offset timer_isr
;int 21h

mov ax, 3509h
int 21h
mov ax, es
mov [old_int9_ptr], bx
mov [old_int9_seg], ax

mov ax, 2509h
mov dx, offset fake_int9
int 21h

mov si, offset strokay
call printmsg

mov sp, 7166
mov [save_sp], sp
sti
mov ax, 3100h
mov dx, 448 ;go TSR, keeping 7 KB
int 21h

save_sp dw 0
ret_ss  dw 0
ret_sp  dw 0

hook_udp:
  pushf
  cli
  mov ah, 3
  mov bx, cs
  mov cx, offset recv_isr
  int 61h
  popf
  ret

send_update db 0

timer_isr:
  pushf
  cli
  mov cs:[ret_ss], ss
  mov cs:[ret_sp], sp
  push ax
  mov ax, word ptr cs:[remote_ip]
  or ax, word ptr cs:[remote_ip+2]  
  pop ax
  jz skip_check ;if the remote IP is not set, just skip it all
  cmp cs:[send_update], 1
  jne skip_check
  ;call send_pkt

  skip_check:
  mov ss, cs:[ret_ss]
  mov sp, cs:[ret_sp]
  popf  
  db 0EAh ;far jump to old int 8h handler
  old_timer_ptr dw 0
  old_timer_seg dw 0

send_pkt:
  push ax
  push bx
  push cx
  push dx
  push es
  push ds
  push si
  push di
  cld
  
  ;now send the packet
    mov ax, cs
    mov ds, ax
    mov dx, cs
    mov di, offset remote_ip
    mov si, offset pkt_vid_ptr
    mov bx, 9002
    mov ax, 9001
    mov es, ax
    mov cx, 1406
    mov ah, 2
    int 61h
    
    mov cs:[send_update], 0
    
  pop di
  pop si
  pop ds
  pop es
  pop dx
  pop cx
  pop bx
  pop ax
  ret

recv_isr:
  push es
  push di
  cmp bx, 9001
  je recv_not_done
  jmp recv_done
recv_not_done:
  mov ax, cs
  mov es, ax
  cmp word ptr ds:[si], 1000
  je set_ip
  cmp word ptr ds:[si], 1001
  je clear_ip
  cmp word ptr ds:[si], 1002
  je insert_key
  cmp word ptr ds:[si], 1003
  jne not_update
  jmp do_update
not_update:
  jmp recv_done
  
  set_ip:
    cld
    mov si, di
    mov ds, dx
    mov di, offset remote_ip
    lodsw
    mov word ptr cs:[remote_ip], ax
    lodsw
    mov word ptr cs:[remote_ip+2], ax
    ;mov di, offset screen
    ;xor ax, ax
    ;mov cx, (80*25)
    ;rep stosw ;clean any old screen buffers, so new clients get immediate update
    jmp recv_done
  
  clear_ip:
    cld
    mov ax, 0
    mov di, offset remote_ip
    stosw
    stosw
    jmp recv_done
  
  insert_key:
    mov ax, offset int9_done
    pushf
    push cs
    push ax
    mov al, ds:[si+2] ;get key scancode from client packet
    jmp int9_start
    
  int9_done:
    mov cs:[int9_flag], 1
    int 9h ;the real int 9h needs to be hit for some programs to see keypress
    mov cs:[int9_flag], 0
    jmp recv_done

  mode_size   dw 4000, 4000, 4000, 4000, 16000, 16000, 16000, 4000, 4000, 4000
              dw 4000, 4000, 4000, 4000, 4000, 4000, 4000, 4000, 4000, 64000  
  mode_seg    dw 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h
              dw 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0B800h, 0A000h
  vid_mem_seg dw 0B800h
  vid_mem_top dw 4000
  vid_mem_ptr dw 0
  do_update:
    cld
    mov ax, 40h ;BIOS data area
    mov ds, ax
    mov bh, ds:[62h] ;get active video page
    mov ah, 3
    int 10h
    mov cs:[pkt_cursor], dx
    
    mov dx, 3D9h
    in al, dx
    mov cs:[pkt_port3d9], al
    
    mov ah, 0Fh ;get video mode
    int 10h
    mov cs:[pkt_vidmode], al
    xor ah, ah    
    mov di, ax
    shl di, 1
    mov bx, offset mode_size
    mov ax, cs:[bx+di]
    mov cs:[vid_mem_top], ax
    mov bx, offset mode_seg
    mov ax, cs:[bx+di]
    mov cs:[vid_mem_seg], ax

    mov cs:[vid_mem_ptr], 0
    
  update_loop:
    mov ax, cs:[vid_mem_ptr]
    cmp ax, cs:[vid_mem_top]
    ja update_done
    
    mov ax, cs:[vid_mem_seg]
    mov ds, ax
    mov ax, cs
    mov es, ax
    mov si, cs:[vid_mem_ptr]
    mov cs:[pkt_vid_ptr], si
    mov di, offset pktbuf
    mov cx, 700
    rep movsw
    mov cs:[vid_mem_ptr], si
    
    call send_pkt
    
    jmp update_loop
  
  update_done:  
    ;mov cs:[vid_mem_ptr], 0
    
    
  recv_done:
    pop di
    pop es
    iret

int9_flag db 0
fake_int9:
  cmp cs:[int9_flag], 1
  je skip_int9
    db 0EAh
    old_int9_ptr dw 0
    old_int9_seg dw 0
  skip_int9:
    iret

printmsg:
  pushf
  push ax
  cld
  printloop:
    lodsb
    cmp al, 0
    jz printdone
    mov ah, 0Eh
    int 10h
    jmp printloop
  printdone:
    pop ax
    popf
    ret


;NOTE: all code below here was taken directly from the generic XT clone BIOS
;source code found on phatcode.net, and slightly modified to use the packet's
;scancode data rather than taking it from the keyboard port.

ascii		db	000h, 037h, 02Eh, 020h	; Scan -> ASCII, sign bit set
		db	02Fh, 030h, 031h, 021h	;   if further work needed
		db	032h, 033h, 034h, 035h
		db	022h, 036h, 038h, 03Eh
		db	011h, 017h, 005h, 012h
		db	014h, 019h, 015h, 009h
		db	00Fh, 010h, 039h, 03Ah
		db	03Bh, 084h, 001h, 013h
		db	004h, 006h, 007h, 008h
		db	00Ah, 00Bh, 00Ch, 03Fh
		db	040h, 041h, 082h, 03Ch
		db	01Ah, 018h, 003h, 016h
		db	002h, 00Eh, 00Dh, 042h
		db	043h, 044h, 081h, 03Dh
		db	088h, 02Dh, 0C0h, 023h
		db	024h, 025h, 026h, 027h
		db	028h, 029h, 02Ah, 02Bh
		db	02Ch, 0A0h, 090h

non_alpha	db	032h, 036h, 02Dh, 0BBh	; Non-Alphabetic secondary
		db	0BCh, 0BDh, 0BEh, 0BFh	;   translation table
		db	0C0h, 0C1h, 0C2h, 0C3h
		db	0C4h, 020h, 031h, 033h
		db	034h, 035h, 037h, 038h
		db	039h, 030h, 03Dh, 01Bh
		db	008h, 05Bh, 05Dh, 00Dh
		db	05Ch, 02Ah, 009h, 03Bh
		db	027h, 060h, 02Ch, 02Eh
		db	02Fh

ctrl_upper	db	040h, 05Eh, 05Fh, 0D4h	; CTRL uppercase secondary
		db	0D5h, 0D6h, 0D7h, 0D8h	;   translation table
		db	0D9h, 0DAh, 0DBh, 0DCh	;   for non-ASCII control
		db	0DDh, 020h, 021h, 023h
		db	024h, 025h, 026h, 02Ah
		db	028h, 029h, 02Bh, 01Bh
		db	008h, 07Bh, 07Dh, 00Dh
		db	07Ch, 005h, 08Fh, 03Ah
		db	022h, 07Eh, 03Ch, 03Eh
		db	03Fh

ctrl_lower	db	003h, 01Eh, 01Fh, 0DEh	; CTRL lowercase secondary
		db	0DFh, 0E0h, 0E1h, 0E2h	;   translation table
		db	0E3h, 0E4h, 0E5h, 0E6h	;   for non-ASCII control
		db	0E7h, 020h, 005h, 005h
		db	005h, 005h, 005h, 005h
		db	005h, 005h, 005h, 01Bh
		db	07Fh, 01Bh, 01Dh, 00Ah
		db	01Ch, 0F2h, 005h, 005h
		db	005h, 005h, 005h, 005h
		db	005h

alt_key		db	0F9h, 0FDh, 002h, 0E8h	; ALT key secondary
		db	0E9h, 0EAh, 0EBh, 0ECh	;   translation table
		db	0EDh, 0EEh, 0EFh, 0F0h
		db	0F1h, 020h, 0F8h, 0FAh
		db	0FBh, 0FCh, 0FEh, 0FFh
		db	000h, 001h, 003h, 005h
		db	005h, 005h, 005h, 005h
		db	005h, 005h, 005h, 005h
		db	005h, 005h, 005h, 005h
		db	005h

num_pad		db	'789-456+1230.' 	; Keypad secondary tralsator

num_ctrl	db	0F7h, 005h, 004h, 005h	; Numeric keypad CTRL secondary
		db	0F3h, 005h, 0F4h, 005h	;   translation table
		db	0F5h, 005h, 0F6h, 005h
		db	005h

num_upper	db	0C7h, 0C8h, 0C9h, 02Dh	; Numeric keypad SHIFT secondary
		db	0CBh, 005h, 0CDh, 02Bh	;   translation table
		db	0CFh, 0D0h, 0D1h, 0D2h
		db	0D3h

int9_start:
	;sti					; Key press hardware interrupt
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es
	cld
	push ax
	mov	ax, 40h
	mov	ds, ax
	pop ax

	mov	ah, al				; Save copy of scan code
	cmp	al, 11111111b			;   check for overrun
	jnz	@@process			;   no, OK
	jmp	@@beep				; Else beep bell on overrun

@@end:	;mov	al, 20h 			; Send end_of_interrupt code
	;out	20h, al 			;   to 8259 interrupt chip

@@exit:
	pop	es				; Exit the interrupt
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret

@@process:
	and	al, 01111111b			; Valid scan code, no break
	cmp	al, 46h
	jbe	@@standard			; Standard key
	jmp	@@pad				; Numeric keypad key

@@standard:
	mov	bx, offset ascii		; Table for ESC thru Scroll Lck
	push ds
	push cs
	pop ds
	xlat  			;   translate to Ascii
	pop ds
	or	al, al				; Sign flags "Shift" type key
	js	@@flag				;   shift, caps, num, scroll etc
	or	ah, ah				; Invalid scan code?
	js	@@end				;   exit if so
	jmp	short @@ascii			; Else normal character

@@flag: and	al, 01111111b			; Remove sign flag bit
	or	ah, ah				;   check scan code
	js	@@shift_up			;   negative, key released
	cmp	al, 10h 			; Is it a "toggle" type key?
	jnb	@@toggle			;   yes
	or	ds:[17h], al			; Else set bit in "flag" byte
	jmp	@@end				;   and exit

@@toggle:
	test	byte ptr ds:[17h], 00000100b	; Control key pressed?
	jnz	@@ascii				;   yes, skip
	test	al, ds:[18h]			; Else check "CAPS, NUM, SCRL"
	jnz	@@end				;   set, invalid, exit
	or	ds:[18h], al			; Show set in "flag_1" byte
	xor ds:[17h], al			;   flip bits in "flag" byte
	jmp	@@end

@@shift_up:
	cmp	al, 10h 			; Released - is it "toggle" key
	jnb	@@toggle_up			;   skip if so
	not	al				; Else form two's complement
	and	ds:[17h], al			;   to do BIT_CLEAR "flags"
	cmp	al, 11110111b			; ALT key release special case
	jnz	@@end				;   no, exit
	mov	al, ds:[19h]			; Else get ALT-keypad character
	mov	ah, 0				;   pretend null scan code
	mov	ds:[19h], ah			;   zero ALT-keypad character
	cmp	al, ah				; Was there a valid ALT-keypad?
	jz	@@end				;   no, ignore, exit
	jmp	@@null				; Else stuff it in ASCII buffer

@@toggle_up:
	not	al				; Form complement of toggle key
	and	ds:[18h], al			;   to do BIT_CLEAR "flag_1"
	jmp	@@end

@@ascii:
	test	byte ptr ds:[18h], 00001000b	; Scroll lock pressed?
	jz	@@no_lock			;   no
	cmp	ah, 45h 			; Is this a NUM LOCK character?
	jz	@@done				;   no
	and	byte ptr ds:[18h], 11110111b	; Else clear bits in "flag_1"

@@done:	jmp	@@end				;   and exit

@@no_lock:
	test	byte ptr ds:[17h], 00001000b	; ALT key pressed?
	jnz	@@alt				;   yes
	test	byte ptr ds:[17h], 00000100b	; CTRL key pressed?
	jnz	@@ctrl				;   yes
	test	byte ptr ds:[17h], 00000011b	; Either shift key pressed?
	jz @@lower_case
	jmp	@@shift				;   yes

@@lower_case:
	cmp	al, 1Ah 			; Alphabetic character?
	ja	@@non_alpha			;   no
	add	al, 'a'-1			; Else add lower case base
	jmp	@@common

@@non_alpha:
	mov	bx, offset non_alpha		; Non-alphabetic character
	sub	al, 20h
	push ds
	push cs
	pop ds
	xlat  			;   do the xlate
	pop ds
	jmp	@@common

@@alt:	cmp	al, 1Ah 			; Control key pressed?
	ja	@@no_ctrl			;   no, skip
	mov	al, 0				; Else illegal key press
	jmp	@@buffer

@@no_ctrl:
	mov	bx, offset alt_key		; Load ALT key translation
	sub	al, 20h 			;   bias to printing char
	push ds
	push cx
	pop ds
	xlat	 			;   do the translation
	pop ds
	jmp	@@common

@@ctrl: cmp	ah, 46h 			; Scroll lock key?
	jnz	@@ctrl_1			;   no, skip
	mov	byte ptr ds:[71h], 10000000b	; Else CTRL-"Scroll" = break
	mov	ax, ds:[80h]			;   get key buffer start
	mov	ds:[1Ch], ax			;   get key tail to start
	mov	ds:[1Ah], ax			;   get key head to start
	int	1Bh				; Issue a "Break" interrupt
	sub	ax, ax
	jmp	@@common_2

@@ctrl_1:
	cmp	ah, 45h 			; Num lock key?
	jnz	@@ctrl_2			;   no, skip
	or	byte ptr ds:[18h], 00001000b	; Else show scroll lock
	mov	al, 20h 			;   send end_of_interrupt
	out	20h, al 			;   to 8259 int controller
	cmp	byte ptr ds:[49h], 7		; Monochrome monitor?
	jz	@@poll				;   yes, skip
	mov	dx, 3D8h			; Else reset mode
	mov	al, ds:[65h]			;   for the
	out	dx, al				;   CGA color card

@@poll: test	byte ptr ds:[18h], 00001000b	; Wait for him to type
	jnz	@@poll				;   not yet
	jmp	@@exit

@@ctrl_2:
	cmp	ah, 3				; Is it a Control @ (null) ?
	jnz	@@ctrl_3			;   no
	mov	al, 0				; Else force a null

@@ctrl_4:
	jmp	@@buffer			;   save in buffer

@@ctrl_3:
	cmp	al, 1Ah 			; Is it a control character?
	jbe	@@ctrl_4			;   yes
	mov	bx, offset ctrl_lower		; Else non-ascii control
	sub	al, 20h 			;   lower case
	push ds
	push cs
	pop ds
	xlat 			;   translation
	pop ds
	jmp	@@common

@@shift:
	cmp	ah, 37h 			; Print_Screen pressed?
	jnz	@@shift_2
	mov	al, 20h 			; Yes, send end_of_interrupt
	out	20h, al 			;   to 8259 interrupt chip
	int	5				; Request print_screen service
	jmp	@@exit				;   and exit key service

@@shift_2:
	cmp	al, 1Ah 			; Alphabetic char?
	ja	@@shift_3			;   no
	add	al, 'A'-1			; Yes, add base for alphabet
	jmp	@@common

@@shift_3:
	mov	bx, offset ctrl_upper		; Non-ascii control
	sub	al, 20h 			;   upper case
	push ds
	push cs
	pop ds
	xlat 			;   translation
	pop ds
	jmp	@@common

@@pad:
	sub	al, 47h 			; Keypad key, convert origin
	mov	bl, ds:[17h]			;   get "flag" byte
	test	bl, 00001000b			; Look for ALT keypad entry
	jnz	@@alt_num			;   do special entry thing
	test	bl, 00000100b			; CTRL key pressed?
	jnz	@@released			;   skip if so
	test	bl, 00100000b			; Toggle "Num Lock" ?
	jz	@@pad_1				;   no, continue
	test	bl, 00000011b			; Shift keys hit?
	jnz	@@pad_2				;   no, check "INS"
	jmp	short @@pad_5			; Else xlat keypad char.

@@pad_1:
	test	bl, 00000011b			; Shift keys hit?
	jz	@@pad_2				;   no, check "INS" key
	jmp	short @@pad_5			; Else xlat keypad char.

@@alt_num:
	or	ah, ah				; ALT-keypad entry, scan code
	js	@@done_2			;   out of range
	test	byte ptr ds:[17h], 00000100b	; Else check CTRL state
	jz	@@alt_num_2			;   not pressed, ALT keypad

@@turbo_patch:
	;cmp	ah, 53h 			; Patch for CTRL ALT - toggle
	;jnz	@@turbo_check			;   not a DEL (reset)
	;mov	word ptr ds:[72h], 1234h		; Ctrl-Alt-Del,	set init flag
	;jmp	warm_boot			;   do a warm reboot

@@turbo_check:
	;cmp	ah, 4Ah 			; Is it a keypad "-" ?
	;jnz	@@alt_num_2			;   no, skip
	;call	toggle_turbo

@@alt_num_2:
	mov	bx, offset num_pad		; Get keypad translation table
	push ds
	push cs
	pop ds
	xlat 			;   convert to number
	pop ds
	cmp	al, '0' 			; Is it a valid ASCII digit?
	jb	@@done_2			;   no, ignore it
	sub	al, 30h 			; Else convert to number
	mov	bl, al				;   save a copy
	mov	al, ds:[19h]			; Get partial ALT-keypad sum
	mov	ah, 0Ah 			;   times 10 (decimal)
	mul	ah
	add	al, bl				; Add in new digit to sum
	mov	ds:[19h], al			;   save as new ALT entry

@@done_2:
	jmp	@@end				; End_of_interrupt, exit

@@released:
	or	ah, ah				; Key released?
	js	@@done_2			;   ignore if so
	mov	bx, offset num_ctrl		; Else Numeric Keypad Control
	push ds
	push cs
	pop ds
	xlat 			;   convert to number
	pop ds
	jmp	short @@common			;   and save it

@@pad_2:
	cmp	ah, 0D2h			; Was "INS" key released?
	jnz	@@pad_3
	and	byte ptr ds:[18h], 01111111b	; Yes, clear "INS" in "FLAG_1"
	jmp	@@done_2

@@pad_3:
	or	ah, ah				; Key released?
	js	@@done_2			;   ignore if so
	cmp	ah, 52h 			; Else check for "INS" press
	jnz	@@pad_4				;   not "INS" press
	test	byte ptr ds:[18h], 10000000b	; Was INS key in effect?
	jnz	@@done_2			;   yes, ignore
	xor	byte ptr ds:[17h], 10000000b	; Else tog "INS" in "FLAG" byte
	or	byte ptr ds:[18h], 10000000b	;   set "INS" in "FLAG_1" byte

@@pad_4: mov	bx, offset num_upper		; Numeric Keypad Upper Case
	push ds
	push cs
	pop ds
	xlat 			;   convert to number
	pop ds
	jmp	short @@common

@@pad_5:
	or	ah, ah				; Was the key released?
	js	@@done_2			;   yes, ignore
	mov	bx, offset num_pad		; Load translation table
	push ds
	push cs
	pop ds
	xlat 			;   convert to number
	pop ds
	jmp	short @@common

@@common:
	cmp	al, 5				; Common entry, char in al
	jz	@@done_3			;   Control E, ignore
	cmp	al, 4
	ja	@@common_1			; Above Control D

	or	al, 10000000b			; Else set sign flag
	jmp	short @@common_2

@@common_1:
	test	al, 10000000b			; Is sign bit set?
	jz	@@common_3			;   skip if so
	and	al, 01111111b			; Else mask sign off

@@common_2:
	mov	ah, al				; Save in high order byte
	mov	al, 0				;   set scan code to zero

@@common_3:
	test	byte ptr ds:[17h], 01000000b	; Test for "CAPS LOCK" state
	jz	@@buffer			;   no, skip
	test	byte ptr ds:[17h], 00000011b	; Test for SHIFT key
	jz	@@common_4			;   skip if no shift
	cmp	al, 'A' 			; Check for alphabetic key
	jb	@@buffer			;   not SHIFT_able
	cmp	al, 'Z' 			; Check for alphabetic key
	ja	@@buffer			;   not SHIFT_able
	add	al, 20h 			; Else do the shift
	jmp	short @@buffer

@@common_4:
	cmp	al, 'a' 			; Check for alphabetic key
	jb	@@buffer			;   not SHIFT_able
	cmp	al, 'z' 			; Check for Alphabetic key
	ja	@@buffer			;   not SHIFT_able
	sub	al, 20h 			; Else do the shift

@@buffer:
	mov	bx, ds:[1Ch]			; bx = tail of buffer
	mov	di, bx				;   save it
	inc	bx				;   advance
	inc	bx				;   by word
	cmp	bx, ds:[82h]			; End of buffer reached?
	jnz	@@check				;   no, skip
	mov	bx, ds:[80h]			; Else bx = beginning of buffer

@@check:
	cmp	bx, ds:[1Ah]			; bx = Buffer Head ?
	jnz	@@stuff				;   no, OK
	jmp	short @@beep			; Else buffer overrun, beep

@@stuff:
	mov	[di], ax			; Stuff scan code, char in buffer
	mov	ds:[1Ch], bx			;   and update buffer tail

@@done_3:
	jmp	@@end

@@beep: mov	al, 20h 			; Keyboard beeper routine
	out	20h, al 			;   send end_of_interrupt
	mov	bx, 80h 			; Cycles in beep
	in	al, 61h 			;   get status
	push	ax				;   save copy
@@cycle:
	and	al, 11111100b			; Mask off speaker bits
	out	61h, al 			;   disable speaker
@@wave:
	mov	cx, 64h 			; Constant for pitch
@@delay:
	loop	@@delay				;   delay, speaker off
	xor	al, 00000010b
	out	61h, al 			; Toggle speaker position
	test	al, 00000010b			; Full cycle done yet?
	jz	@@wave				;   no, do other half cycle
	dec	bx				; Else show cycle sent
	jnz	@@cycle				;   more cycles to send
	pop	ax
	out	61h, al 			; Restore flags
	mov	cx, 32h 			; Silence counter
@@delay_end:
	loop	@@delay_end			; Send nothing for while
	jmp	@@end

@@null: mov	ah, 38h 			; ALT key pressed, released
	jmp	@@buffer			;   for no logical reason

;end of code from BIOS

remote_ip db 0, 0, 0, 0

pkt_vid_ptr dw 0
pkt_cursor  dw 0
pkt_vidmode db 3
pkt_port3d9 db 0
pktbuf      dw 1400 dup (0)

strwelcome db 'Remoter v0.11.8.6 (c)2011 Mike Chambers', 13, 10
           db '[A UDP-based remote control server for DOS]', 13, 10, 13, 10
           db 'Initializing... ', 0
strokay    db 'OK!', 13, 10
           db 'Going TSR!', 13, 10, 0

END entry_point
